// This code is used to check the correctness of besselk.f

#include <math.h>
#include <float.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>

#ifdef __cplusplus
extern "C" {
#endif

extern void zbesk_(double *zr, double *zi, double *fnu, int *kode, int *n,
                   double cyr[], double cyi[], int *nz, int *ierr);

#ifdef __cplusplus
}
#endif

#define LEN 56

int main(int argc, char **argv) {
  double fnu = 3.1;
  double zr = 1.2;
  double zi = 0;
  int kode = 1;
  int n = 1;
  double cyr[1];
  double cyi[1];
  int nz;
  int ierr;

  zbesk_(&zr, &zi, &fnu, &kode, &n, cyr, cyi, &nz, &ierr);

  char output[LEN+1] = "cyr[0] = 4.55423672200606, cyi[0] = 0, nz = 0, ierr = 0\n";
  char output2[LEN+1];
  snprintf(output2, LEN, "cyr[0] = %.14f, cyi[0] = %g, nz = %d, ierr = %d\n",
           cyr[0], cyi[0], nz, ierr);
  output2[LEN-1] = '\n';
  output2[LEN] = '\0';

  if (strncmp(output, output2, LEN) != 0) {
    printf("Correct output: %s", output);
    printf("Computed output: %s", output);
    printf("besselk test failed!\n");
    printf("Please manually set the dmach data and imach data in besselk.f\n");
    exit(1);
  }
  else {
    printf("Correct output: %s", output);
    printf("besselk test passed.\n");
    return 0;
  }
}

// Author: J. Chen
// $Date: 2013/03/28 15:50:43$
